indexing

	description: "Parses XML document, reads DTD and generates parser."


class

	XIP


inherit

	STDC_CURRENT_PROCESS

	EXCEPTIONS

	ARGUMENTS


creation

	make


feature

	make is
		do
			print ("DTD parser 0.2.%N")
			if argument_count = 0 then
				print_help
			else
				create schema.make
				parse
				generate
			end
		end


feature -- actual work

	schema: SCHEMA_SPECIFICATION

	parse is
		local
			parser: DTD_PARSER
			file: KL_TEXT_INPUT_FILE
			filename: STRING
		do
			create parser.make (schema)

			filename := argument (1)
			create file.make (filename)
			file.open_read

				check
					file_open: file.is_open_read
				end

			parser.parse_from_stream (file)

			if not parser.is_correct then
				print ("Parsing failed: either the file is incorrect XML or the DTD cannot be read.%N")
				exit_with_failure
			end

			if schema.root_element = Void then
				print ("root element not set. This indicates that there was no <!DOCTYPE statement in the given XML file.%N")
				exit_with_failure
			end
		end

--		generate is
--			local
--				template: TEMPLATE_PARSER
--				filename: UC_STRING
--			do
--				create template.make (schema)
--				create filename.make_from_string (argument (2))
--				template.generate (filename)
--			end

	generate is
			-- output flat XML structure
		local
			xml: EPX_XML_WRITER
			out_file: STDC_TEXT_FILE
			cursor: DS_LINEAR_CURSOR [DEFINED_ELEMENT]
		do
			create xml.make
			xml.add_header_utf_8_encoding
			xml.add_system_doctype ("flatSchema", "flatSchema.dtd")
			xml.start_tag ("flatSchema")
			xml.add_tag ("rootElement", schema.root_element)
			cursor := schema.elements.new_cursor
			from
				cursor.start
			until
				cursor.after
			loop
				xml.start_tag("element")
				xml.set_attribute ("name", cursor.item.name)
				xml.set_attribute ("type", cursor.item.content_specification)
				cursor.item.generate_child_definition (xml)
				xml.stop_tag
				cursor.forth
			end
			xml.stop_tag
			create out_file.create_write ("flat.xml")
			out_file.puts (xml.xml)
			out_file.close
		end


feature -- help

	print_help is
		do
			print ("Usage:%N")
			print ("  xip xml_file_with_doctype.xml%N")
		end


end
